/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
orderingServices.factory('ConfirmModalService', function ($uibModal) {
    var modalDefaults = {
        backdrop: true,
        keyboard: true,
        modalFade: true,
        templateUrl: 'templates/custom/confirm-modal.html'
    };

    var modalOptions = {
        closeButtonText: 'Close',
        actionButtonText: 'OK',
        headerText: 'Proceed?',
        bodyText: 'Perform this action?'
    };

    var showModal = function (customModalDefaults, customModalOptions) {
        if (!customModalDefaults) customModalDefaults = {};
        customModalDefaults.backdrop = 'static';
        return show(customModalDefaults, customModalOptions);
    };

    var show = function (customModalDefaults, customModalOptions) {
        //Create temp objects to work with since we're in a singleton service
        var tempModalDefaults = {};
        var tempModalOptions = {};

        //Map angular-ui modal custom defaults to modal defaults defined in service
        angular.extend(tempModalDefaults, modalDefaults, customModalDefaults);

        //Map modal.html $scope custom properties to defaults defined in service
        angular.extend(tempModalOptions, modalOptions, customModalOptions);

        if (!tempModalDefaults.controller) {
            tempModalDefaults.controller = function ($scope, $uibModalInstance) {
                $scope.modalOptions = tempModalOptions;
                $scope.modalOptions.ok = function (result) {
                    $uibModalInstance.close(true);
                };
                $scope.modalOptions.close = function (result) {
                    $uibModalInstance.close(false);
                };
            };
        }

        return $uibModal.open(tempModalDefaults).result;
    };

    return {
        showModal : showModal
    };
});
orderingServices.factory('InformationModalService', function (ConfirmModalService) {


    var showModal = function (headerTextArg, bodyTextArg) {
        var modalDefaults = {
            backdrop: true,
            keyboard: true,
            modalFade: true,
            templateUrl: 'templates/custom/information-modal.html'
        };

        var modalOptions = {
            headerText: headerTextArg,
            bodyText: bodyTextArg
        };
        ConfirmModalService.showModal(modalDefaults,modalOptions);
    };


    return {
        showModal : showModal
    };
});


