/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

orderingServices.factory('CreateOrderServices', function ($q, DocumentResource, NewDocument, PdescResource, SiteResource) {

    var getRentalItems = function () {
        var getPromise = $q.defer();
        PdescResource.getPdescs().then(function(singles){
            console.log(singles);
            var pdescs = [];
            
            angular.forEach(singles,function(each){
                var contains = false;
                if( pdescs.length === 0 ){
                    contains = false;
                }else{
                    angular.forEach(pdescs,function( pdesc ){
                        if( pdesc.pdesc === each.pdesc){
                            contains = true;
                        }
                    });
                }
                
                if( !contains ){
                     pdescs.push( each );
                };
                
            });
            
            getPromise.resolve( pdescs ); 
        });
        return getPromise.promise;
    };
    
    
    

    var getCustomerSites = function (customer) {
        var getPromise = $q.defer();
        SiteResource.getCustomerSimpleSiteBeans(customer).then(function (customerSites) {
            getPromise.resolve(customerSites);
        });
        return getPromise.promise;
    };


    var createDetailLine = function(selectedPdesc){
        var detailLine = {};
        detailLine.pdesc = selectedPdesc.pdesc;
        detailLine.qty = 1;
        detailLine.fromDate = new Date();
        detailLine.toDate = new Date();
        detailLine.lineNumber = 1;
        return detailLine;
    };

    var createNewOrder = function (order) {
        //var getPromise = $q.defer();

        NewDocument.clearDocument();// make sure we arefresh

        var orderDocument = NewDocument.getDocument();
        
        orderDocument.documentType = 6; // order
        orderDocument.customer = order.combinedCustomerBean;
        orderDocument.site = order.selectedCustomerSite;
        orderDocument.contact = {"id": order.contact.id ,"name": order.contact.name };
        orderDocument.selectedOperator = 1 ; // hardcode to administrator for now , later change to a CORS Operator
        orderDocument.patient = order.patient;
        orderDocument.detailLines.push( createDetailLine( order.selectedRentalItem ) );


        

//        $http({method: 'POST', data: orderDocument, url: Configuration.getConfiguration().documentPostUrl }).
//                            success(function (data, status, headers, config) {
//                            
//                                console.log(data);
//                                
//                                
//
//                                if (data != null && data.status === 'SUCCESS') {
//                                    
//                                    getPromise.resolve(true);
//
//                                } else {
//                                    getPromise.reject(true);
//                                    
//                                }
//
//                            }).
//                            error(function (data, status, headers, config) {
//                                console.log("Failed To Create Order");
//                                console.log(data);
//                                console.log(data);
//                                console.log(data);
//                                console.log(data);
//                                
//                                
//                                getPromise.reject(true);
//                                
//                            });

        return DocumentResource.documentSync( orderDocument );
    };

    return{
        getRentalItems: getRentalItems,
        getCustomerSites: getCustomerSites,
        createNewOrder: createNewOrder

    };


});

