/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */



orderingServices.factory('NewDocument', function (ConstantDefinitions) {
    // Service shared between the wizard pages to make up a new document.

    var newDocument = {};

    newDocument.documentType = {};
    newDocument.originalDocumentType = 0;
    newDocument.documentNumber = 0;
    newDocument.customer = {};
    newDocument.site = {};
    newDocument.contact = {};
    newDocument.selectedPlant = {};
    newDocument.equipment = [];
    newDocument.selectedProductType = {};
    newDocument.selectedMeterType= {};
    newDocument.extras = {};
    newDocument.productTypes = [];
    newDocument.selectedDetailLine = {};
    newDocument.originalDetailLines = []; // used by returns and collections for requiredLines generation
    newDocument.detailLines = [];
    newDocument.requiredLines = [];
    newDocument.comment = "";
    newDocument.customerRef = "";
    newDocument.lat = 0;
    newDocument.lng = 0;
    newDocument.photosURL = [];
    newDocument.photosBase64 = [];
    
    newDocument.detailLineLocations = [];
    newDocument.selectedPhotoLocation = {};

    newDocument.creationDate = new Date(); //DateUtilities.dateToYMD( new Date() );
    newDocument.scheduledDate = new Date();
    newDocument.selectedOperator = 0;
    newDocument.selectedSalesPerson = 0;
    newDocument.location = 1;
    newDocument.policy = "";
    newDocument.calendar = "";
    newDocument.priceList = "";
    newDocument.tender = "";
    newDocument.discount = "";
    newDocument.discHire = 0.00;
    newDocument.discSale = 0.00;
    newDocument.customerOrderNo = "";
    newDocument.clockingState = 0;
    newDocument.signature = null;
    newDocument.engineerSignature = null;
    newDocument.operator = {};
    newDocument.showCustomer = false;
    newDocument.showSite = false;
    newDocument.showContact = false;
    newDocument.showJobTasks = false;
    newDocument.showTimeLogged = false;
    newDocument.completedDocument = true;
    newDocument.signatureContact = {};
    newDocument.localClockingHistory = [];
            
            
    return {
        getDocument: function () {
            return newDocument;
        },
        clearDocument: function () {
            newDocument = {};
            newDocument.documentNumber = 0;
            newDocument.documentType = {};
            newDocument.originalDocumentType = 0;
            newDocument.customer = {};
            newDocument.site = {};
            newDocument.contact = {};
            newDocument.selectedPlant = {};
            newDocument.extras = {};
            newDocument.equipment = [];
            newDocument.creationDate = new Date(); //DateUtilities.dateToYMD( new Date() );
            newDocument.scheduledDate = new Date(); //DateUtilities.dateToYMDHM( new Date() );
            newDocument.comment = "";
            newDocument.customerRef = "";
            newDocument.lat = 0;
            newDocument.lng = 0;
            newDocument.selectedOperator = 0;
            newDocument.selectedProductType = {};
            newDocument.selectedMeterType= {};
            newDocument.productTypes = [];
            newDocument.originalDetailLines = [];
            newDocument.detailLines = [];
            newDocument.requiredLines = [];
            newDocument.selectedDetailLine = {};
            newDocument.photosURL = [];
            newDocument.photosBase64 = [];
            newDocument.detailLineLocations = [];
            newDocument.selectedPhotoLocation = {};
            
            
            newDocument.selectedSalesPerson = 0;
            newDocument.location = 1;
            newDocument.policy = "";
            newDocument.calendar = "";
            newDocument.priceList = "";
            newDocument.tender = "";
            newDocument.discount = "";
            newDocument.discHire = 0.00;
            newDocument.discSale = 0.00;
            newDocument.customerOrderNo = "";
            newDocument.clockingState = 0;
            newDocument.signature = null;
            newDocument.engineerSignature = null;
            newDocument.operator = {};
            newDocument.showCustomer = false;
            newDocument.showSite = false;
            newDocument.showContact = false;
            newDocument.showJobTasks = false;
            newDocument.showTimeLogged = false;
            newDocument.completedDocument = true;
            newDocument.signatureContact = {};
            newDocument.localClockingHistory = [];
        },
        setDocument: function (document) {
            newDocument = document;
        },
        getConstantDefinitions: function () {
            return ConstantDefinitions;
        }

    };
});


orderingServices.factory('ConstantDefinitions', function () {
    var documentRequestType = {};
    documentRequestType.contract = 1;
    documentRequestType.offhire = 2; 
    documentRequestType.return = 3;
    documentRequestType.invoice = 4; 
    documentRequestType.quotation = 5; 
    documentRequestType.order = 6;
    documentRequestType.servicejob = 7;
    documentRequestType.contractPOD = 8;
    documentRequestType.modifyContract = 9;
    documentRequestType.changeOver = 10;

    getDocumentTypeText = function (type) {
        if (type === documentRequestType.contract)
            return "Contract";
        if (type === documentRequestType.offhire)
            return "Collection";
        if (type === documentRequestType.return)
            return "Return";
        if (type === documentRequestType.invoice)
            return "Invoice";
        
        if (type === documentRequestType.quotation)
            return "Quotation";
        if (type === documentRequestType.order)
            return "Order";
        if (type === documentRequestType.servicejob)
            return "Service Job";
        if (type === documentRequestType.contractPOD)
            return "Contract POD";
        if (type === documentRequestType.modifyContract)
            return "Modify Contract";
            if (type === documentRequestType.changeOver)
            return "ChangeOver";
    
    }
    
    getHmheadDocumentTypeText= function(type){
        if (type === 1)
            return "Contract";
        if (type === 2)
            return "Return";
        if (type === 3)
            return "Delivery";
        if (type === 4)
            return "Changeover";
        if (type === 5)
            return "Adjustment";
        if (type === 6)
            return "Deletion";
        if (type === 7)
            return "Offhire";
        if (type === 17)
            return "Reverse Offhire";
        if (type === 20)
            return "Invoice";
    }

    return {
        getDocumentRequestType: function () {
            return documentRequestType;
        },
        getDocumentTypeText: getDocumentTypeText,
        getHmheadDocumentTypeText: getHmheadDocumentTypeText
    };
});
